<?  // Library with general common functions

$rpc_lk;

function rpc_trace_debug($msg)
{
	global $HTTP_USER_AGENT;

    if ( $HTTP_USER_AGENT )
        echo "<HTML><font color=red><B>TRACE : $msg</B></font><br></HTML>\n";
}

function rpc_log_text($text, $logname='')
{
    global $id,$name ;
    
    if ( empty($logname) )
    {
	    if ( !empty($name) )
	        $logname = $name ;
	    else if ( !empty($id) )
	        $logname = rpc_player_name($id) ;
	    else
	        $logname = "UNKNOW" ;
	}

    $fp=fopen("private/".date("Ymd",time())."_log.txt","a");

    $line = "" ;
    $textline = strtok($text, "\n") ;
    while ( $textline )
    {
        $line .= date("d/m H:i:s",time())."\t$logname\t$textline\n";
        $textline = strtok("\n") ;
    }

    fputs($fp,$line);
    fclose($fp); 
}

// Connect to server and select DB
function rpc_connect_db()
{
	global $db_server, $db_user_login, $db_user_pass, $db_name;

	$linkid = @mysql_connect("$db_server","$db_user_login","$db_user_pass") 
	            or rpc_return_error("SQL", "database error", "Error mysql_connect : ".mysql_error()) ;
	@mysql_select_db($db_name,$linkid) 
	    or rpc_return_error("SQL", "database error", "Error mysql_select_db : ".mysql_error());
	return $linkid;
}

// Send a SQL request and display an error msg in case of
function rpc_send_sql($sql,$message)
{
	if(!$res = @mysql_query($sql))
		rpc_return_error ("SQL", "database error",  "Error mysql_query ($message): ".mysql_error());
	return $res;
}

function rpc_check_session($id,$session)
{
	global $rpc_lk,$db_prefix;

  $rpc_lk = rpc_connect_db();
  
  $sql_request = "SELECT id FROM {$db_prefix}player_list ".
                 "WHERE (id=\"$id\" AND session=\"$session\")";
  $sql_result = rpc_send_sql($sql_request,"Test if session is correct");
  if ( !mysql_num_rows($sql_result) )
    rpc_return_error("SESSION", "Session error", "Error check_session($id,$session)");
      
  $sql_req = "UPDATE {$db_prefix}player_list ".
             "SET date_refresh=CURRENT_TIMESTAMP ".
             "WHERE id=\"$id\" AND session=\"$session\"";
  $sql_res = rpc_send_sql($sql_req,"update ip in player_list");       
}

function rpc_return_result($rpc_result)
{
	global $rpc_lk, $HTTP_USER_AGENT;

    if ( $log_result )
        rpc_log_text($rpc_result."\n");
    
    mysql_close($rpc_lk);

    $rpc_result = "<rpc>\n".$rpc_result."</rpc>\n";
    
    if ( !$HTTP_USER_AGENT )
        echo $rpc_result;
    else
    {
        echo "<HTML>\n";
        echo nl2br(htmlspecialchars($rpc_result));
        echo "<br><br>";
        echo "<a href=\"./debug/\">Return to index</a>";
        echo "</HTML>";
    }

    exit;
}

function rpc_return_error($error_code, $error_msg, $debug_msg)
{
    rpc_trace_debug("\"$error_code\",\"$error_msg\",$debug_msg");
    rpc_return_result("<status>ERR</status>\n<errcode>$rpc_error</errcode>\n<errmsg>$error_msg</errmsg>\n");
}

//-------------------------------------
function chat_sendmsg_old($name, $msg, $flag=0)
{
  global $db_prefix ;

  $sql_req = "INSERT INTO {$db_prefix}chat (flag,time,name,msg) ".
             "VALUES ('$flag',CURRENT_TIMESTAMP,'$name','$msg')";
  $sql_res = rpc_send_sql($sql_req,"insert msg in chat table");
}

function chat_sendmsg($name, $msg)
{
    $fmsg = file("chatmsg.php");

	$fnewmsg = "";
	while ( list( $num_line, $line ) = each( $fmsg ) ) 
	{
		if ( $num_line > 0 )
			$fnewmsg .= $line;
	}
	$fnewmsg .= "<font color=#E0E000>&nbsp;<?=chat_date(".time().", time());?> [<b>$name</b>] $msg<br></font>\n";
	
	$fp = fopen("chatmsg.php", "w");
	fwrite($fp, $fnewmsg);
	fclose($fp);
}

function date_rel_5char($date1, $date2)
{
    $laps = $date2 - $date1 ;
    
    if ( $laps < 0 )
        $str =                             "### " ;
    else if ( $laps < 60 )
        $str = intval($laps).              " sec " ;
    else if ( $laps < 600 )
        $str = "&nbsp;".intval($laps/60).  " min " ;
    else if ( $laps < 3600 )
        $str = intval($laps/60).           " min " ;
    else if ( $laps < 24*3600 )
        $str = intval($laps/3600).         " h " ;
    else if ( $laps < 2*24*3600 )
        $str = intval($laps/(24*3600)).    " day " ;
    else if ( $laps < 90*24*3600 )
        $str = intval($laps/(24*3600)).    " days " ;
    else
        $str = intval($laps/(30*24*3600)). " months" ;
    
    return $str ;
}

//-------------------------------------
// flag :
define ("MSG_FLAG_WEB_ANONYMOUS",  0x0000) ;    // chat msg from anonymous visitor
define ("MSG_FLAG_WEB_IDENTIFIED", 0x0001) ;    // chat msg from web site (identified visitor)
define ("MSG_FLAG_WEB_ADMIN",      0x0002) ;    // chat msg from web site (admin)
define ("MSG_FLAG_PUB_WSRV_LVL1",  0x0004) ;    // public WorldServer message level 1 (login,logout,)
define ("MSG_FLAG_PUB_WSRV_LVL2",  0x0008) ;    // public WorldServer message level 2 (change map, die)
define ("MSG_FLAG_PUB_WSRV_LVL3",  0x0010) ;    // public WorldServer message level 3 (kill monster)
define ("MSG_FLAG_PRIV_WSRV_LVL1", 0x0020) ;    // internal WorldServer message level 1 (error)
define ("MSG_FLAG_PRIV_WSRV_LVL2", 0x0040) ;    // internal WorldServer message level 2 (heartbeat, ping, start a server, stop a server)
define ("MSG_FLAG_PRIV_WSRV_LVL3", 0x0080) ;    // internal WorldServer message level 3 (trace)
//-------------------------------------
function chat_getmsg($nb_msg, $debug = 0, $where_clause = "" )
{
    global $db_prefix ;
    
    $text = "" ;
    $sql_request = "SELECT * FROM {$db_prefix}chat $where_clause ORDER BY id DESC LIMIT 0, $nb_msg ;";
    $sql_result = rpc_send_sql($sql_request,"Get chat msg");
    
    if ( $debug == 1 )
    {
        $text = "<table border=0 cellspacing=0 cellpadding=0 width=3000><tr><td>" ;
        $text .= dump_request($sql_result, $nb_msg) ;
        $text .= "</td></tr></table>" ;
    }
    else
    {
        while ( $nb_msg>0 && ($chat=mysql_fetch_object($sql_result)) )
        {
            // YYYY-MM-DD HH:MM:SS
            $chat_time = mktime(
                substr($chat->time,11,2),   // HH
                substr($chat->time,14,2),   // MM
                substr($chat->time,17,2),   // SS
                substr($chat->time, 5,2),   // MM
                substr($chat->time, 8,2),   // DD
                substr($chat->time, 0,4));  // YYYY
            $line = date_rel_5char($chat_time,time()) ;
            $line .= "[<b>$chat->name</b>] $chat->msg<br>\n" ;
            switch ( $chat->flag )
            {
                case MSG_FLAG_WEB_ANONYMOUS :
                    $color = "#E0E000";  break;
                case MSG_FLAG_WEB_IDENTIFIED :
                    $color = "#FFFF00";  break;
                case MSG_FLAG_WEB_ADMIN :
                    $color = "#00FF00";  break;

                case MSG_FLAG_PUB_WSRV_LVL1 :
                    $color = "#FF0000";  break;
                case MSG_FLAG_PUB_WSRV_LVL2 :
                    $color = "#E00000";  break;
                case MSG_FLAG_PUB_WSRV_LVL3 :
                    $color = "#D00000";  break;
                
                case MSG_FLAG_PRIV_WSRV_LVL1 :
                    $color = "#0000FF";  break;
                case MSG_FLAG_PRIV_WSRV_LVL2 :
                    $color = "#0000E0";  break;
                case MSG_FLAG_PRIV_WSRV_LVL3 :
                    $color = "#0000D0";  break;
                default : $color = "#FFFFFF";  break;
            }
            $line = "<font color=$color>$line</font>";
            $text = $line.$text ;
            $nb_msg-- ;
        }
    }
    return $text ;
}

//-------------------------------------

function rpc_player_name($id)
{
    global  $db_prefix ;
    
    // Get the current score        
    $sql_request = "SELECT name FROM {$db_prefix}player_info WHERE id='$id'";
    $sql_result = rpc_send_sql($sql_request,"Get the player info");
    if ( !mysql_num_rows($sql_result) )
        rpc_return_error ("PARAM", "invalid id", "id=$id");
    $player_info = mysql_fetch_object( $sql_result ) ;
    
    return $player_info->name ;
}

?>
